##==============================================================================================================
##Clear workspace
##Set working directory
##Load relevant libraries
##==============================================================================================================
	rm(list=ls())
	setwd("C:\\")

	require(data.table)
	require(ggplot2)

##==============================================================================================================
##Import data
##==============================================================================================================
	load("divorced_EU_level_long_no_y.RData")
	load("divorced_EU_level_long_no_s.RData")
	load("divorced_EU_level_long_complete.RData")
	
	dat_long <- rbind(divorced_EU_level_long_complete, divorced_EU_level_long_no_y)
	dat_long <- rbind(dat_long, divorced_EU_level_long_no_s)

	dat_long$type[dat_long$type == "No earnings prospects preference"] <- "No earnings prospects pref."
	dat_long$type[dat_long$type == "No education preference"] 		   <- "No education pref."
	
##==============================================================================================================
##Figure 7
##==============================================================================================================			
	ggplot(data=dat_long[dat_long$variable == "log_ratio_hyper_hypo",],
		aes(x=five_cohort_short_double, y=value, group = type, shape = type, linetype=type)) +
		labs(list(x = "Marriage cohort",  y = expression("Relative divorce risk" ~ " (" ~ italic(R)~ ")"))) +
		ylim(-.4, .4) +

		geom_line()+
		geom_point(fill = "black", size = 2) +
		geom_hline(yintercept=0) + 		
			
		theme(axis.text.y 			= element_text(colour="black", size = 10)) + 
		theme(axis.text.x 			= element_text(colour="black", size = 10, angle = 45,hjust = 1)) + 
		theme(axis.title			= element_text(colour="black", size = 12)) +		
		theme(axis.ticks 			= element_line(colour = 'black')) +
		theme(axis.line = element_line(color = 'black')) +
		
		theme(panel.grid.minor.x 	= element_blank()) +
		theme(panel.grid.major.x 	= element_blank()) +
		theme(panel.grid.major.y 	= element_blank()) +
		theme(panel.grid.minor.y 	= element_blank()) +
		theme(panel.border 			= element_blank()) +
		theme(panel.background 		= element_blank()) +	
		
		theme(text 					= element_text(size=10)) +
		theme(legend.text			= element_text(size=10)) +
		theme(legend.position		= "bottom") +
		theme(legend.key 			= element_rect(fill = 'white')) +
		theme(legend.title			= element_text(size = 10)) +
		
		guides(shape = guide_legend(nrow = 2,byrow=TRUE, 'Model version'), linetype = guide_legend("Model version"), fill = "none") +
		scale_shape_manual(values=c(24,21,25, 4))